/*
 * TABDMS: convert column from/to HMS/DMS
 *
 *      24-jul-94  V0.1 created	PJT
 *	28-aug-98   0.2 ?
 *      13-sep-00   0.3 added hms PJT  - but not finished
 */

#include <stdinc.h>
#include <getparam.h>
#include <ctype.h>

string defv[] = {                /* DEFAULT INPUT PARAMETERS */
    "in=???\n           input file name(s)",
    "out=???\n          output file name",
    "todms=\n           list of columns to convert to dms",
    "tohms=\n           list of columns to convert to hms",
    "separator=:\n      separator between output D-M-S.S",
    "VERSION=0.3\n      13-sep-99 PJT",
    NULL
};

string usage = "Convert to HMS/DMS tables";



stream instr, outstr;			/* file streams */

string sep;                             /* separator */

#define MAXCOL          256             /* MAXIMUM number of columns */
#define MLINELEN       8196		/* max linelength of a line */

bool   keepc[MAXCOL+1];                 /* columns to keep (t/f) in old fmt */
int    ndelc;                           /* actual number of skip columns */
int    dmsmode;				/* dms or hms mode */

extern string *burststring(string, string);


nemo_main()
{
    int i;

    setparams();

    instr = stropen(getparam("in"),"r");
    outstr = stropen (getparam("out"),"w");

    convert(instr,outstr);

}

setparams()
{
    string delcol;                          /* which columns not to write */
    int    delc[MAXCOL];                    /* columns to skip for output */
    int i;

    if (hasvalue("todms")) {
    	delcol = getparam("todms");
    	ndelc = nemoinpi(getparam("todms"),delc,MAXCOL);
    	dmsmode = 1;
    } else if (hasvalue("tohms")) {
    	delcol = getparam("tohms");
    	ndelc = nemoinpi(getparam("tohms"),delc,MAXCOL);
   	dmsmode = 1;
    } else
    	error("Need to supply either tohms= or todms=");
    for (i=0; i<MAXCOL; i++)        /* keep in old format */
        keepc[i]=TRUE;
    if (ndelc<0 || ndelc>MAXCOL)
            error("Too many columns given (%d) to work with (MAXCOL %d)",
			ndelc,MAXCOL);
    for (i=0; i<ndelc; i++) {
       keepc[delc[i]]=FALSE;
    }

    sep = getparam("separator");
}



convert(stream instr, stream outstr)
{
    char   line[MLINELEN];          /* input linelength */
    double dval;        
    int    nval, i, nlines, sign;
    string *outv;                   /* pointer to vector of strings to write */
    string seps=", \t";             /* column separators  */
    real   dd, mm, ss;
        
    nlines=0;               /* count lines read so far */
    for(;;) {                       /* loop over all lines in file(s) */

        if (!get_line(instr, line))
            return 0;
        dprintf(3,"LINE: (%s)\n",line);
	if(line[0] == '#') continue;		/* don't use comment lines */
        nlines++;


        outv = burststring(line,seps);
        i=0;
        while (outv[i]) {
            if (keepc[i+1]) {
                fputs(outv[i],outstr);
                fputs(" ",outstr);
            } else {
                if (nemoinpd(outv[i],&dval,1)<0) 
                    error("syntax error decoding %s",outv[i]);
                sign = SGN(dval);
                dval = ABS(dval);
                dd = floor(dval);
                dval = (dval-dd)*60.0;
                mm = floor(dval);
                ss = (dval-mm)*60.0;
                fprintf(outstr,"%g",dd*sign);
                fprintf(outstr,"%s",sep);
                fprintf(outstr,"%g",mm);
                fprintf(outstr,"%s",sep);
                fprintf(outstr,"%g ",ss);
            }
            i++;
        }
        fputs("\n",outstr);
    } /* for(;;) */
}
