/* split_pathname.c -	Split path into directory and name
 *
 * SYNOPSIS
 *	char *split_pathname (const char *pathname, char *directory,
 *              char *name)
 *
 * DESCRIPTION
 *	Extracts the directory part and the name part of a Unix pathname.
 *	Returns a pointer to the name part.
 *
 * Copyright (c) 1991 Tim Cook.
 * Non-profit distribution allowed.  See README for details.
 */

static char rcsid[] = "$Header: split_pathname.c 1.0 91/03/22 $" ;

#include <string.h>
#define NULL_CP		((char *) 0)
#define EOS		'\0'


char *split_pathname (pathname, directory, name)
   char *pathname, *directory, *name ;
{
   char *p ;

   strcpy (directory, pathname) ;
   while ((p = strrchr (directory, '/')) != NULL_CP && p[1] == EOS) *p = EOS ;
   if (p == NULL_CP) {
      strcpy (name, pathname) ;
      directory[0] = EOS ; }
   else {
      strcpy (name, p + 1) ;
      if (p == directory) {	/* The slash is at the start of pathname */
	 directory[1] = EOS ; }
      else {
	 *p = EOS ; } }
   return name ; }


#ifdef TEST
#include <stdio.h>

int main (argc, argv)
   int argc ;
   char **argv ;
{
   char directory[256] ;
   char name[256] ;

   if (split_pathname (argv[1], directory, name) == NULL_CP) {
      fprintf (stderr, "%s: couldn't parse \"%s\"\n", argv[0], argv[1]) ; }
   else {
      printf ("pathname:  \"%s\"\ndirectory: \"%s\"\nname:     \"%s\"\n",
	 argv[1], directory, name) ; }
   }
#endif
